//blaster.h

#ifndef BLASTER_H
#define BLASTER_H

#include <qcolor.h>
#include <q3textedit.h>
//Added by qt3to4:
#include <QPixmap>


class QRect;
class bunnies;
class QPixmap;
class QImage;

#define RGBHILOSIZE 6

class blaster
{
	
	public:
		
		blaster();
		~blaster();
		
		int getBunnyRect(bunnies * pbl, int nbunny, QRect & rc, int maxright, int maxbottom);
		int getSurroundingRect(QRect & inner, QRect & rc);
		int calcRgbGradients(QImage & img, int innerradius, int outerradius, int xshift, int yshift);
		int interpolate(bunnies * pbl, int nbunny, QPixmap * pmjpg);
		QPixmap& getBunnyPixmap(bunnies * pbl, int nbunny, QPixmap * pmjpg, QPoint& pt);
		int undoBlast(QPixmap * pmjpg, QPixmap& pmbunny, QPoint& pt);
		int interpolatePixel(QImage & img, QRgb & rgb, int centerx, int centery, int col, int row, int radius );
		bool blasterThreshholdMet();
		void logger(char* pstr);
		
		// these can be called from command line
		int interpolateQImage( QImage & img, bunnies * pbl, int nbunny );
		int blastBunnyFromQImage( QImage & img, bunnies* pbl, int nbunny );
		
		static int radius(int inx, int iny, int outx, int outy);
		static int getXYShift(QRect & rcinner, int maxright, int maxbottom, int* pxshift, int* pyshift);
	
	public:	
		
		Q3TextEdit *pLogEdit;
		FILE * fpLogFile;
	
	private:
	
		int rgbhilos[RGBHILOSIZE];
		int avgrgbrange;
		long rgbSum;
};

#endif

