//canvas.cpp

#include <qpainter.h>
#include <qrect.h>
#include <qmenubar.h>
//Added by qt3to4:
#include <QPixmap>

#include "canvas.h"
#include "bunny.h"
#include "mainwin.h"
#include <QPen>

//#define DEBUGOUT
#ifdef DEBUGOUT

#include <iostream>
#define cout std::cout
#define endl std::endl

#endif

extern bunnies * pBunnies;
extern mainwin * pMainWin;

canvas::canvas(int w, int h)
  : Q3Canvas(w, h)
{

}

canvas::~canvas()
{

}

//This has to be reimplemented from QCanvas to be nofified when drawing 
//should happen. 
void canvas::drawForeground ( QPainter & painter, const QRect & clip )
{
	//Gets rid of unused parametr warning
	int x = clip.x();
	x=x;
	
	switch (pMainWin->getState())
	{
		case CREATE_REFERENCE:
		case OPEN_IMG:
		{
			if (pBunnies == 0) return;
			
			switch (pMainWin->appSettings.markerColor)
			{
				case RED:
					painter.setPen( Qt::red );
					break;
				case GREEN:
					painter.setPen( Qt::green );
					break;
				case BLUE:
					painter.setPen( Qt::blue );
					break;
				case YELLOW:
					painter.setPen( Qt::yellow );
					break;
				default:
					break;
			}
			
			//If we're manually blasting, create the marker
			//out of a dashed line
			QPen pen, savedpen;
			if (pMainWin->getState() == OPEN_IMG)
			{
				pen = savedpen = painter.pen();
				pen.setStyle(Qt::DashLine);
				painter.setPen(pen);
			}
			
#ifdef DEBUGOUT
			cout << "drawForeground starting" << endl;
#endif  
			bunny *pb = pBunnies->getAt(0);
			while (pb != 0)
			{
#ifdef DEBUGOUT    
				cout << "drawForeground painting" << endl;
#endif    
				painter.drawEllipse( (pb->getX() - pb->getDia() / 2), 
									(pb->getY() - pb->getDia() / 2), 
									pb->getDia(), 
									pb->getDia() );
				pb = pb->getNext();
			}
			
			//restore the original pen
			if (pMainWin->getState() == OPEN_IMG)
			{
				painter.setPen(savedpen);
			}
		} //end case CREATE_REFERENCE or OPEN_IMG
		default:
		{
			break;
		}
	} //end switch
}

void canvas::drawBackground ( QPainter & painter, const QRect & clip )
{
#ifdef DEBUGOUT
	cout << "drawBackground" << endl;
#endif

	QPixmap *pm = pMainWin->pixmap();

	if (pm != (QPixmap*)0)
	{
		if (pm->isNull() == false)
		{
			painter.drawPixmap( 0, 0, *pm );
		}
	}
	else
	{
		Q3Canvas::drawBackground(painter, clip);
	}
}
