//
// C++ Interface: dbbconfig
//
// Description: 
//
//
// Author: ,,, <heinzg@denizen>, (C) 2006
//
// Copyright: See COPYING file that comes with this distribution
//
//

#ifndef DBBCONFIG_CUST
#define DBBCONFIG_CUST

#include <qobject.h>

#include "ui_dbbconfig_base.h"
#include "settings.h"


class dbbconfig : public QDialog, public Ui::dbbconfig_base
{

Q_OBJECT

	public:
		dbbconfig( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, Qt::WFlags fl = 0 );
		~dbbconfig();
	
	public slots:
		virtual void AvgLightness_sliderMoved( int );
		virtual void AvgColorGradient_sliderMoved( int );
		virtual void SaveQuality_sliderMoved( int );
		virtual void BtnCancel_clicked();
		virtual void BtnOk_clicked();
		virtual void SaveQuality_valueChanged( int );
		virtual void AvgLightness_valueChanged( int );
		virtual void AvgColorGradient_valueChanged( int );
		virtual void btnHelpPath_clicked();
		virtual void ckboxDisableThreshhold_clicked();
		
		virtual void BtnOutputDir_clicked();
		virtual void ckboxDisableHotpixels_clicked();
		virtual void ckboxHotPixelOnly_clicked();
		virtual void btnReset_clicked();
		virtual void btnDefault_clicked();
		virtual void btnApply_clicked();
		virtual void outDirChanged(const QString&);
		
	protected:
		void initSliders();	
		void initWidgets();
		void updateSaveQualityText(int quality);
		void updateAvgLightnessText(int lightness);
		void updateAvgColorGradientText(int gradient);
		void enableThreshholdSliders(bool bEnabled);
		void saveConfiguration();
		void setState(int state);
		
	public:
		QString sHelpDir;
		bool bThreshholdsDisabled;
		bool bHotPixelsDisabled;
		bool bHotPixelsOnly;
		
	private:
		struct settings savedSettings;
		enum states {NEW, DIRTY, SAVED};
		int state;

};

#endif


