//mainwin.h
#ifndef MAINWIN_H
#define MAINWIN_H

#include <q3mainwindow.h>
#include <qlabel.h>
#include <qstatusbar.h>
//Added by qt3to4:
#include <QPixmap>
#include <QMouseEvent>
#include <QCloseEvent>
#include "canvasview.h"
#include "canvas.h"
#include "settings.h"
#include "pixlist.h"

enum states {IDLE, CREATE_REFERENCE, OPEN_IMG, BATCH_BLAST, BLAST_TEST};
enum substates {OPEN_IMG_DIRTY=1, OPEN_IMG_SAVED, CREATE_REFERENCE_DIRTY,
                CREATE_REFERENCE_SAVED};
enum menuitems {CREATEREF=1, OPENREF, SAVEREF, CLOSEREF, CONFIGDBBLAST, 
	            BATCHBLAST, DBBLASTHELP, ABOUTDBBLAST, ABOUTQT };

class Q3Canvas;
class Q3CanvasView;
class QMouseEvent;
class QPixmap;


class mainwin: public Q3MainWindow
{
	Q_OBJECT
	
public:
	
	mainwin();
	~mainwin();
	
	int getState() {return state;};
	void setState(int st) {state = st;};
	void setState(int state, int substate);
	QPixmap* pixmap() {return ppixmap;};
	pixlist* pixList() {return ppixlist;}; 
	
	
	
protected:
	
	void createMenu();
	void initCanvas();
	void showImage(QString & s); 
	void getFileOpenName(QString & s);
	void createStatusBar();
	void closeEvent(QCloseEvent *e);
	void loadSettings();
	void saveSettings();
	
private slots:
	
	void createReferenceFile();
	int saveReferenceFile();
	void openReferenceFile();	
	void closeReferenceFile();
	void cleanupBunniesAndPixmap();
	void openImageFile();
	int saveImageFile();
	int saveImageFileAs();
	int saveImageAndCopyExifData(QString& sIn, QString&sOut);
	void closeImageFile();
	void testBlast();
	void configureDbblast();
	void batchBlast();
	void showHelp();
	void aboutDbblast();
	void aboutQt();
	
public:
	
		QStatusBar * pstatusbar;
		QLabel * pstatuslabel;
		struct settings appSettings;
		
		QMenu * pfileMenu;
		QAction *pcreateRefAct;
		QAction *popenRefAct;
		QAction *psaveRefAct;
		QAction *pcloseRefAct;
		QAction *ptestBlastAct;
    	QAction *pexitAct;
		QAction *popenImageAct;
		QAction *psaveImageAct;
		QAction *psaveImageAsAct;
		QAction *pcloseImageAct;
		
		QMenu * psettingsMenu;
		QAction *pconfigureAct;
		
		QMenu * ptoolsMenu;
		QAction * pbatchBlastAct;
		
		QMenu * phelpMenu;
		QAction * phelpAct;
		QAction * paboutAct;
		QAction * paboutQtAct;
	
private:
	
	int state;
	canvas * pcanvas;
	QPixmap * ppixmap;
	canvasview * pcanvasview;    
	QString sfilename;
	pixlist *ppixlist;
};


#endif 
